<template>
    <teleport to="body">
        <transition name="modal-fade">
            <div class="modal-backdrop">
                <div
                    class="modal"
                    role="dialog"
                    aria-labelledby="modalTitle"
                    aria-describedby="modalDescription"
                >
                    <header
                        class="modal-header w-full flex justify-between"
                    >
                        <span
                            class="modal-header-title flex-grow overflow-ellipsis text-ellipsis"
                        >
                            <slot name="title" />
                        </span>
                        <button
                            type="button"
                            class="btn-close"
                            aria-label="Close modal"
                            @click="close"
                        >
                            x
                        </button>
                    </header>
                    <section
                        class="modal-body overflow-y-scroll"
                        :style="{
                            'max-height': maxHeight + 'px',
                        }"
                    >
                        <slot name="body" />
                    </section>

                    <footer
                        v-if="hasFooter"
                        class="modal-footer flex justify-end space-x-2"
                    >
                        <slot name="footer" />
                        <button
                            type="button"
                            class="btn btn-close"
                            aria-label="Close modal"
                            @click="close"
                        >
                            Close
                        </button>
                    </footer>
                </div>
            </div>
        </transition>
    </teleport>
</template>

<script setup>
import {onBeforeUnmount, onMounted, useSlots, computed, ref} from "vue";
import EventBus from "!/event-bus.js";

const props = defineProps({
    hasFooter: {
        required: false,
        type: Boolean,
        default: true,
    }
});
const emit = defineEmits(['close', 'update']);

const $slots = useSlots();
const maxHeight = ref(300);
const headerHeight = 48;
const footerHeight = 64;

const close = () => {
    emit('close');
};

const hasTitle = computed(() => {
    return $slots.title && $slots.title().length;
});

const handleEsc = (evt) => {
    if (evt.key === 'Escape' || evt.keyCode === 27) {
        emit('close');
    }
};

onMounted(() => {
    EventBus.emit('MODAL_OPEN');

    if (props.hasFooter) {
        maxHeight.value = ((window.innerHeight / 100) * 75) - (headerHeight + footerHeight);
    } else {
        maxHeight.value = ((window.innerHeight / 100) * 75) - headerHeight;
    }

    document.addEventListener('keyup', handleEsc);
});

onBeforeUnmount(() => {
    document.removeEventListener('keyup', handleEsc);
    EventBus.emit('MODAL_CLOSE');
});
</script>
